#include <vcl.h>
#include <DateUtils.hpp>
#include <FileCtrl.hpp>
#include <Clipbrd.hpp>
#pragma hdrstop
#include "UnitControlSkype.h"
#pragma package(smart_init)
#pragma resource "*.dfm"

#define DeltaDate 25569 // 1970 - 1901  
#define DeltaTime 14400 // 4   ( )

TFormControlSkype *FormControlSkype;

__fastcall TFormControlSkype::TFormControlSkype(TComponent* Owner) : TForm(Owner)
{
  // 
  Created                 = 1;
  CaptionThisProgram      = "Control Skype";
  if (AlreadyRunning()) {Application->Terminate(); return;} //  
  DBSkype                 = 0;
  ListMS                  = new TList();
  SLTemp                  = new TStringList();
  Caption                 = CaptionThisProgram;
  MainClassSkype          = "tSkMainForm";
  PageControl->ActivePage = TabSheetMessages;
  PanelTop->Caption       = "";
  EditEmail->Text         = "";
  EditEmailPassword->Text = "";
  EditEmailRecieve->Text  = "";
  EditPathMan->Text       = "";
  EditEmailSubject->Text  = "  Skype";
  EditEmailText->Text     = "";
  EditTimerInterval->Text = "15";
  EditTimerScan->Text     = "3";
  EditPathDB->Text        = "";
  LastCaptionSkype        = "";
  SkipInformTimer         = 0;
  TrayIconID              = 0;
  CanCloseProgram         = 0;
  DTLastInform            = Now();
  Left                    = 100;
  Top                     = 100;
  PopupMenuTrayIcon       = new TPopupMenu(this);
  MouseX = 0;
  MouseY = 0;
  MouseC = 0;

  //  
  PfneIni = GetStrReplace(Application->ExeName,".exe",".ini");
  if (FileExists(PfneIni))
   {
	 SLTemp->LoadFromFile(PfneIni);
	 StrToFormBounds(SLTemp->Values["FormBounds"],this);
	 EditEmail->Text          = SLTemp->Values[EditEmail->Name];
	 EditEmailPassword->Text  = SLTemp->Values[EditEmailPassword->Name];
	 EditEmailRecieve->Text   = SLTemp->Values[EditEmailRecieve->Name];
	 EditEmailSubject->Text   = SLTemp->Values[EditEmailSubject->Name];
	 EditEmailText->Text      = SLTemp->Values[EditEmailText->Name];
	 EditTimerInterval->Text  = SLTemp->Values[EditTimerInterval->Name];
	 EditTimerScan->Text      = SLTemp->Values[EditTimerScan->Name];
	 EditPathDB->Text         = SLTemp->Values[EditPathDB->Name];
	 EditPathMan->Text        = SLTemp->Values[EditPathMan->Name];
	 CheckBoxControl->Checked     = StrToIntDef(SLTemp->Values[CheckBoxControl->Name],     0);
	 CheckBoxKeyInterval->Checked = StrToIntDef(SLTemp->Values[CheckBoxKeyInterval->Name], 0);
	 CheckBoxMan->Checked         = StrToIntDef(SLTemp->Values[CheckBoxMan->Name],         0);
	 CheckBoxAutoNotification->Checked     = StrToIntDef(SLTemp->Values[CheckBoxAutoNotification->Name],     0);
	 EditTime1->Text              = SLTemp->Values[EditTime1->Name]; if (EditTime1->Text=="") EditTime1->Text = "00:00";
	 EditTime2->Text              = SLTemp->Values[EditTime2->Name]; if (EditTime2->Text=="") EditTime2->Text = "24:00";
	 if (this->Left<0) //    ,   
	  {
		if (Screen->MonitorCount==1) {this->Left = 0; this->Top = 0;}
	  }
   }
  if ((EditEmail->Text=="")&&(EditPathMan->Text==""))
   {
	 Visible = 1;
	 PageControl->ActivePage = TabSheetSetting;
   }

  if (EditPathDB->Text=="")
   {
	 //       
	 char p[256];
	 int retVal = GetEnvironmentVariable("APPDATA", p, sizeof(p));
	 if (retVal>0)
	  {
		AStr A = p;
		A = A + "\\Skype";
		if (DirectoryExists(A))
		 {
		   TStringList* Dirs = new TStringList();
		   FindAllDirs(A,Dirs);
		   for (int i=0; i<Dirs->Count; i++)
			{
			  AStr B = A + "\\" + Dirs->Strings[i] + "\\main.db";
			  if (FileExists(B))
			   {
				 EditPathDB->Text = B;
				 break;
			   }
			}
		   delete Dirs;
		 }
		//Inform(A);
	  }
   }
  EditPathDBMan->Text = EditPathDB->Text;
  Created                 = 0;
  CheckBoxControlClick(NULL);
  if (CheckBoxAutoNotification->Checked)
   {
	 Inform("     ''");
   }
}

void __fastcall TFormControlSkype::FormClose(TObject *Sender, TCloseAction &Action)
 {
   //   
   if (DBSkype!=0) {delete DBSkype; DBSkype = 0;}
   //  
   SLTemp->Clear();
   SLTemp->Add("//ControlSkype");
   SLTemp->Add("[Setting]");
   SLTemp->Add("FormBounds="        + FormBoundsToStr(this));
   SLTemp->Add("EditEmail="         + EditEmail->Text);
   SLTemp->Add("EditEmailPassword=" + EditEmailPassword->Text);
   SLTemp->Add("EditEmailRecieve="  + EditEmailRecieve->Text);
   SLTemp->Add("EditEmailSubject="  + EditEmailSubject->Text);
   SLTemp->Add("EditEmailText="     + EditEmailText->Text);
   SLTemp->Add("EditTimerInterval=" + EditTimerInterval->Text);
   SLTemp->Add("EditTimerScan="     + EditTimerScan->Text);
   SLTemp->Add("EditPathDB="        + EditPathDB->Text);
   SLTemp->Add("EditPathMan="         + EditPathMan->Text);
   SLTemp->Add("CheckBoxControl="     + IntToStr((int)CheckBoxControl->Checked));
   SLTemp->Add("CheckBoxKeyInterval=" + IntToStr((int)CheckBoxKeyInterval->Checked));
   SLTemp->Add("CheckBoxMan="         + IntToStr((int)CheckBoxMan->Checked));
   SLTemp->Add("CheckBoxAutoNotification="     + IntToStr((int)CheckBoxAutoNotification->Checked));
   SLTemp->Add("EditTime1="           + EditTime1->Text);
   SLTemp->Add("EditTime2="           + EditTime2->Text);
   SLTemp->SaveToFile(PfneIni);
   for (int i=0; i<ListMS->Count; i++)
	delete (TMessageSkype*) ListMS->Items[i];
   delete ListMS;
   delete SLTemp;
   TrayIconRemove();
 }

int __fastcall TFormControlSkype::AlreadyRunning(void)
 {
   // ,    
   int res = 0;
   HWND hWND = GetWindow(GetForegroundWindow(),GW_HWNDFIRST);
   while (hWND!=NULL) //     
	{
	  int l = GetWindowText(hWND,p,sizeof(p));
	  if (l==CaptionThisProgram.Length())
	   {
		 AStr B = p;
		 if (B==CaptionThisProgram)
		  {
			res = 1;
			break;
		  }
	   }
	  hWND = GetNextWindow(hWND,GW_HWNDNEXT);
	}
   return res;
 }

void __fastcall TFormControlSkype::TrayIconAdd(TImage* Image, AStr Hint)
 {
   // /    
   DWORD dw = NIM_MODIFY;
   if (TrayIconID==0)
	{
	  TrayIconID = 1117;
	  dw = NIM_ADD;
	}
   TrayIcon = new Graphics::TIcon;
   TrayIcon->Handle= (HICON) LoadImage(HInstance,"MAINICON",IMAGE_ICON,0,0,0);
   NOTIFYICONDATA IconData;
   IconData.cbSize           = sizeof(NOTIFYICONDATA);
   IconData.uID              = TrayIconID;
   IconData.hWnd             = Handle;
   IconData.uFlags           = NIF_MESSAGE|NIF_ICON|NIF_TIP;
   IconData.uCallbackMessage = WM_TRAYNOTIFY;
   if (Image==NULL)
	IconData.hIcon = TrayIcon->Handle;
   else
	IconData.hIcon = (HICON) Image->Picture->Icon->Handle;
   lstrcpy(IconData.szTip, Hint.c_str());
   Shell_NotifyIcon(dw,&IconData);
 }

void __fastcall TFormControlSkype::TrayIconRemove(void)
 {
   //     
   if (TrayIconID!=0)
	{
	  NOTIFYICONDATA IconData;
	  IconData.cbSize           = sizeof(NOTIFYICONDATA);
	  IconData.uID              = TrayIconID;
	  IconData.hWnd             = Handle;
	  IconData.uFlags           = NIF_MESSAGE|NIF_ICON|NIF_TIP;
	  IconData.uCallbackMessage = WM_TRAYNOTIFY;
	  Shell_NotifyIcon(NIM_DELETE,&IconData);
	  TrayIconID = 0;
   }
 }

void __fastcall TFormControlSkype::TrayIconNotify(TMessage &Msg)
 {
   //      
   //  LPARAM     .
   //    ,  .
   //    ,  .
   switch(Msg.LParam)
	{
	  case WM_LBUTTONDOWN:
	   {
		 //ShowWindow(Application->Handle, SW_SHOW);
		 Visible = !Visible;
		 SetForegroundWindow(Handle);
		 PostMessage(Handle, WM_NULL, 0,0);
		 break;
	   }
	  case WM_RBUTTONUP:
	   {
		 PopupMenuTrayIcon->Items->Clear();
		 PopupMenuTrayIconAddItem(2,Timer->Enabled,"");
		 PopupMenuTrayIconAddItem(3,TimerScan->Enabled,"");
		 PopupMenuTrayIconAddItem(4,TimerAutoNotification->Enabled,"  ");
		 PopupMenuTrayIconAddItem(1,0,"");
		 PopupMenuTrayIconAddItem(0,0,"");
		 PopupMenuTrayIcon->Popup(Mouse->CursorPos.x, Mouse->CursorPos.y);
		 PostMessage(Handle, WM_NULL, 0,0);
		 break;
	   }
	}
 }

void __fastcall TFormControlSkype::PopupMenuTrayIconClick(TObject* Sender)
 {
   //    
   int Tag      =  ((TMenuItem*)Sender)->Tag;
   int Checked  =  1 - ((TMenuItem*)Sender)->Checked;
   switch (Tag)
	{
	  case 1: {CanCloseProgram = 1; Close(); break;}
	  case 2: {CheckBoxControl->Checked          = Checked; break;}
	  case 3: {CheckBoxMan->Checked              = Checked; break;}
	  case 4: {CheckBoxAutoNotification->Checked = Checked; break;}
	}
 }

void __fastcall TFormControlSkype::PopupMenuTrayIconAddItem(int Tag, int Checked, AStr dCaption)
 {
   //      
   TMenuItem*   NewItem = new TMenuItem(PopupMenuTrayIcon);
   NewItem->Tag         = Tag;
   NewItem->Caption     = dCaption;
   NewItem->OnClick     = PopupMenuTrayIconClick;
   NewItem->Checked     = Checked;
   PopupMenuTrayIcon->Items->Add(NewItem);
 }

int __fastcall TFormControlSkype::StrToStrsWS(const AStr S, const AStr Delim, TStrings *Ss)
 {
 /*
      S    Ss (Ss ),
     Delim -  ,
     : S="Canvas=10,2044444,5676", Delim=",=",
     : "Canvas"
              "10"
              "2044444"
			  "5676",
	  - .
       StrToStrs ,        
 */
   Ss->Clear();
   if (S.IsEmpty()) return 0;
   if (Delim.IsEmpty())
    {
	  Ss->Add(S);
	  return 1;
    }
   AStr Str = "";
   AStr C = "";
   int i = 1;
   while (i<=S.Length())
    {
      C = S.SubString(i,1);
      Str = Str + C;
      if (C.LastDelimiter(Delim))
       {
          Ss->Add(Str.SubString(1,Str.Length()-1));
          Str = "";
        }
      i++;
    }
   Ss->Add(Str);
   return Ss->Count;
 }

AStr __fastcall TFormControlSkype::FormBoundsToStr(TForm *Form)
 {
   //         "Left,Top,Width,Height".
   if (Form->WindowState==wsMaximized) return "wsMaximized";
   if (Form->WindowState==wsMinimized) return "wsMinimized";
   return IntToStr(Form->Left)  +","+ IntToStr(Form->Top) +","+
		  IntToStr(Form->Width) +","+ IntToStr(Form->Height);
 }

void __fastcall TFormControlSkype::StrToFormBounds(AStr S, TForm *Form)
 {
   //         "Left,Top,Width,Height".
   if (S.IsEmpty()) return;
   if (S=="wsMaximized") {Form->WindowState = wsMaximized; return;}
   if (S=="wsMinimized") {Form->WindowState = wsMinimized; return;}
   TStringList *SL = new TStringList();
   StrToStrsWS(S,",",SL);
   if (SL->Count < 4) return;
   Form->Left   = StrToIntDef(SL->Strings[0],Form->Left);
   Form->Top    = StrToIntDef(SL->Strings[1],Form->Top);
   Form->Width  = StrToIntDef(SL->Strings[2],Form->Width);
   Form->Height = StrToIntDef(SL->Strings[3],Form->Height);
   delete SL;
   return;
 }

AStr __fastcall TFormControlSkype::DTToStr(const System::TDateTime Value)
 {
   //         "2008-04-08 23:00:05"
   return FormatDateTime("yyyy-mm-dd hh:mm:ss",Value);
 }

AStr __fastcall TFormControlSkype::GetStrReplace(const AStr Value, const AStr S1, const AStr S2)
 {
   //   Value,     S1   S2.
   AStr S = Value;
   int i0 = 1, i = S.Pos(S1);
   while (i>=i0)
	{
      S.Delete(i,S1.Length());
      S.Insert(S2,i);
      i0 = i + S2.Length();
      i  = i0 + S.SubString(i0,S.Length()-i0+1).Pos(S1) - 1;
	}
   return S;
 }

AStr __fastcall TFormControlSkype::ExtractPathFromPfne(const AStr Pfne)
 {
 /*
           Pfne,
        .
      ExtractFileDir,    :
     ExtractFileDir      .
 */

   AStr A = ExtractFileDir(Pfne);
   if (A.Length()==3)
    if (A.Pos("\\")==3)
     A = A.SubString(1,2);
   return A;
 }

int __fastcall TFormControlSkype::FindAllDirs(const AStr Path, TStrings *Dirs)
 {
 /*
        (Dirs )
          -,
     Path=="",    .
 */

   AStr CurPath = GetCurrentDir();
   Dirs->Clear();
   AStr P = Path.UpperCase();
   if (P=="") P = CurPath;
   if (!SetCurrentDir(P)) return 0;
   TSearchRec sr;
   if (FindFirst("*.*",faAnyFile,sr) == 0)
    {
      if ((sr.Name!=".")&&(sr.Name!="..")&&(sr.Attr&faDirectory))
       Dirs->Add(sr.Name);
      while(FindNext(sr) == 0)
       if ((sr.Name!=".")&&(sr.Name!="..")&&(sr.Attr&faDirectory))
        Dirs->Add(sr.Name);
    }
   FindClose(sr);
   SetCurrentDir(CurPath);
   return Dirs->Count;
 }

void __fastcall TFormControlSkype::Inform(AStr Value)
 {
   //     
   if (MemoInform->Lines->Count>60*60*24/4) MemoInform->Lines->Clear();
   if (SkipInformTimer)
	{
	  MemoInform->Lines->Add(Value);
	}
   else
	{
	  TDateTime DTThis = Now();
	  MemoInform->Lines->Add(DTToStr(DTThis)+" (" +IntToStr((int)MilliSecondsBetween(DTThis,DTLastInform))+") - " + Value);
	  DTLastInform = DTThis;
	}
 }

void __fastcall TFormControlSkype::ControlSkype(void)
 {
   //        
   AStr FindCaption = "";
   HWND hWND = GetWindow(GetForegroundWindow(),GW_HWNDFIRST);
   while (hWND!=NULL) //     
	{
	  int l = GetClassName(hWND,p,sizeof(p));
	  if (l==MainClassSkype.Length())
	   {
		 AStr B = p;
		 if (B==MainClassSkype)
		  {
			l = GetWindowText(hWND, p, sizeof(p));
			FindCaption = p;
			break;
		  }
	   }
	  hWND = GetNextWindow(hWND,GW_HWNDNEXT);
	}
   if (FindCaption!="") //    
	{

	  if (LastCaptionSkype!=FindCaption) //    
	   {
		 if ((FindCaption.Pos("[")>0)&&(FindCaption.Pos("]")>0)) //   
		  {
			//Inform(FindCaption); //  
			EditEmailText->Text = FindCaption;
			if (EditPathDB->Text!="") //        
			 {
			   DefineLastMessageSkype();
			 }
			ButtonEmailSendClick(0);
		  }
		 LastCaptionSkype = FindCaption;
	   }
	}
 }

void __fastcall TFormControlSkype::Keystroke(void)
 {
	   //    ,     
	   keybd_event(VK_LEFT,NULL,NULL,NULL);
	   Sleep(10);
	   keybd_event(VK_LEFT,NULL,KEYEVENTF_KEYUP,NULL);
	   Sleep(10);
	   keybd_event(VK_RIGHT,NULL,NULL,NULL);
	   Sleep(10);
	   keybd_event(VK_RIGHT,NULL,KEYEVENTF_KEYUP,NULL);
 }

void __fastcall TFormControlSkype::TimerTimer(TObject *Sender)
 {
   //   
   if ((EditTime1->Text!="00:00")&&(EditTime2->Text!="24:00"))
	{
	  //   ,       ,    
	  AStr A = FormatDateTime("hh:mm",Now());
	  if (EditTime1->Text>A) return;
	  if (EditTime2->Text<A) return;
	}
   if (CheckBoxKeyInterval->Checked) Keystroke();
   if ((EditEmail->Text!="")&&(EditEmail->Text.Pos('@')>0))
	 {
	   ControlSkype();
	 }
 }

void __fastcall TFormControlSkype::TimerSwitch(void)
 {
   //  
   if (Created) return;
   if ((CheckBoxControl->Checked)||(CheckBoxMan->Checked))
	{
	  Timer->Interval         = StrToIntDef(EditTimerInterval->Text,5)*1000;
	  EditTimerInterval->Text = IntToStr((int)(Timer->Interval/1000));
	  TimerScan->Interval     = StrToIntDef(EditTimerScan->Text,3)*1000;
	  EditTimerScan->Text     = IntToStr((int)(TimerScan->Interval/1000));
	  if ((EditPathDB->Text!="")&&(FileExists(EditPathDB->Text)))
	   {
		 if (DBSkype!=0) {delete DBSkype; DBSkype = 0;}
		 DBSkype = new TSQLiteDatabase(EditPathDB->Text);
		 //DBSkype->SetTimeout(10);
		 //DBSkype->ExecSQL(AnsiToUtf8("SQLITE_OPEN_READONLY"));
	   }
	  TrayIconAdd(0,Caption);
	  if (CheckBoxControl->Checked) CheckBoxControl->Hint = "  : " + DTToStr(Now());
	  if (CheckBoxMan->Checked)     CheckBoxMan->Hint     = "  : " + DTToStr(Now());
	}
   else
	{
	  TrayIconAdd(ImageTrayStop,Caption+" ()");
	  if (DBSkype!=0) {delete DBSkype; DBSkype = 0;}
	}
   Timer->Enabled     = CheckBoxControl->Checked;
   TimerScan->Enabled = CheckBoxMan->Checked;
 }

void __fastcall TFormControlSkype::ButtonEmailSendClick(TObject *Sender)
 {
   //    
   PageControl->ActivePage = TabSheetMessages;
   int pos = EditEmailRecieve->Text.Pos('@');
   if (pos==0)
	{
	  Inform("   !");
	  return;
	}
   if (EditEmailPassword->Text.Length()==0)
	{
	  Inform("   !");
	  return;
	}
   pos = EditEmail->Text.Pos('@');
   if (pos==0)
	{
	  Inform("   !");
	  return;
	}
   AStr Host = "smtp." + EditEmail->Text.SubString(pos+1,EditEmail->Text.Length()-pos);

   TIdMessage* M = new TIdMessage(FormControlSkype);
   M->From->Text = EditEmail->Text;                        // 
   M->Subject    = EditEmailSubject->Text;                 //  
   M->Recipients->Add();
   M->Recipients->Items[0]->Text = EditEmailRecieve->Text; // 
   AStr B = RusToLatin(EditEmailText->Text); //   MultiByteToWideChar  
   //Inform(B); return; //  
   M->Body->Add(B.SubString(1,100)); //  

   //     
   //if (EditEmailFile->Text!="")
   //	if (FileExists(EditEmailFile->Text))
   //	 new TIdAttachmentFile(M->MessageParts,EditEmailFile->Text);

   TIdSMTP* IdSMTP1 = new TIdSMTP(this);
   IdSMTP1->AuthType = satDefault;
   IdSMTP1->Host     = Host;
   IdSMTP1->Username = EditEmail->Text;
   IdSMTP1->Password = EditEmailPassword->Text;
   int ok = 0;
   try
	{
	  IdSMTP1->Connect();
	  if(IdSMTP1->Connected())
	   {
		 IdSMTP1->Send(M);
		 IdSMTP1->Disconnect();
		 ok = 1;
	   }
	  else
	   {
		 Inform("    ");
		 ok = -1;
	   }
	}
   catch (Exception& E)
	{
	  ok = -1;
	  Inform("   - " + AnsiString(E.ClassName()) + ": " + E.Message);
	}
   delete M;
   delete IdSMTP1;
   if (ok==1)
	{
	  Inform("   " + EditEmailRecieve->Text + " - " + EditEmailText->Text);
	}
 }

void __fastcall TFormControlSkype::CheckBoxControlClick(TObject *Sender)
 {
   // / 
   TimerSwitch();
   if ((CheckBoxControl->Checked)&&(Visible))
	{
	  MemoInform->SetFocus();
	}
 }

void __fastcall TFormControlSkype::Label1MouseDown(TObject *Sender, TMouseButton Button, TShiftState Shift, int X, int Y)
 {
   //    
   ShellExecute(Application->Handle,NULL,"www.moolex.ru",NULL,NULL,SW_SHOW);
 }

void __fastcall TFormControlSkype::Label1MouseLeave(TObject *Sender)
 {
   //       
   ((TLabel *)Sender)->Font->Color = clNavy;
 }

void __fastcall TFormControlSkype::Label1MouseMove(TObject *Sender, TShiftState Shift, int X, int Y)
 {
   //       
   ((TLabel *)Sender)->Font->Color = clBlue;
 }

void __fastcall TFormControlSkype::FormCloseQuery(TObject *Sender, bool &CanClose)
 {
   //   
   if (CanCloseProgram==0)
	 {
	   CanClose = 0;
	   if (Visible) Visible  = 0;
	 }
 }

void __fastcall TFormControlSkype::CheckBoxViewPasswordClick(TObject *Sender)
 {
   EditEmailPassword->PasswordChar = (CheckBoxViewPassword->Checked) ? 0 : '*';
 }

AStr __fastcall TFormControlSkype::CP1251ToAnsi(System::UnicodeString U)
 {
   AStr  A = "";
   unsigned char* p =(unsigned char*) U.w_str();
   char p2[3]; p2[2] = 0;
   int   j =        0;
   while(p[j]!=0)
	{
	  if ((p[j]==0xD0)||(p[j]==0xD1))
	   {
		 p2[0] = p[j];
		 j++;
		 p2[1] = p[j];
		 AStr B = p2;
		 AStr C = Utf8ToAnsi(B);
		 A = A + C;
	   }
	  else
	   {
		 p2[0] = p[j];
		 p2[1] = 0;
		 A = A + p2;
	   }
	  j++;
	}

   return A;
 }

int __fastcall TFormControlSkype::DefineLastMessageSkype(void)
 {
   int res = 0;
   if ((DBSkype!=0)&&(DBSkype->TableExists("Messages")))
	   {
		 //Inform(" Messages ");
		 AStr A = "select [id], [author], [from_dispname], [dialog_partner], [body_xml], [edited_by] from Messages ORDER BY id DESC LIMIT 1";
		 try
		  {
			TSQLiteTable* table = DBSkype->GetTable(AnsiToUtf8(A));
			for (int i=0; i<table->Count; i++)
			 {
			   //Inform(IntToStr((int)table->FieldType(2)));
			   AStr B = CP1251ToAnsi(table->FieldAsString(2));
			   AStr C = CP1251ToAnsi(table->FieldAsString(4));
			   AStr D = B + " - " + C;
			   EditEmailText->Text = D;
			   table->Next();
		     }
		  }
		 catch (...)
		  {
			EditEmailText->Text = "error access";
		  }
	   }
	  else
	   {
		 Inform(" Messages ");
		 res = -1;
	   }
   /*
   //    
   TSQLiteDatabase* dbn = new TSQLiteDatabase("D:\\test.db");
   AStr A = "CREATE TABLE Test (id INTEGER PRIMARY KEY AUTOINCREMENT,d_date DATE)";
   dbn->ExecSQL(AnsiToUtf8(A));
   delete dbn;
   */
   return res;
 }

int __fastcall TFormControlSkype::AllMessagesToFile(void)
 {
   TStringList* SL = new TStringList();
   TStringList* SL2 = new TStringList();

   int res = 0;
   if ((DBSkype!=0)&&(DBSkype->TableExists("Messages")))
	{
		 //Inform(" Messages ");
		 AStr A = "select [id], [author], [from_dispname], [dialog_partner], [timestamp], [body_xml] from Messages";
		 TSQLiteTable* table = DBSkype->GetTable(AnsiToUtf8(A));
		 for (int i=0; i<table->Count; i++)
		  {
			AStr TS = CP1251ToAnsi(table->FieldAsString(4)); // Inform(TS);
			int  ts = StrToIntDef(TS,0);
			AStr A = CP1251ToAnsi(table->FieldAsString(1));
			AStr F = CP1251ToAnsi(table->FieldAsString(2));
			AStr D = CP1251ToAnsi(table->FieldAsString(3));
			SL2->Text = CP1251ToAnsi(table->FieldAsString(5));
			AStr T    =	GetStrReplace(TSToTime(ts),"-",":");

			SL->Add("["+TSToDate(ts)+" "+T+"="+IntToStr(SL2->Count+3)+"]");
			SL->Add("author="+A);
			SL->Add("dispname="+F);
			SL->Add("dialog="+D);
			SL->AddStrings(SL2);
			table->Next();
			res++;
		  }
	  //AStr Pfne = EditPathDB->Text;
	  //Pfne      = GetStrReplace(Pfne.LowerCase(),"main.db","messages.txt");
	  AStr Pfne = ExtractPathFromPfne(Application->ExeName)+"\\skype-messages.txt";
	  SL->SaveToFile(Pfne);
	  Inform(Pfne);
	  Inform("  = "+ IntToStr(res));
	}
   else
	{
	  Inform(" Messages ");
	  res = -1;
	}
   delete SL;
   delete SL2;
   return res;
 }

AStr __fastcall TFormControlSkype::RusToLatin(AStr V)
 {
   AStr C = " A_  B_  V_  G_  D_  E_  ZH  Z_  I_  YI  K_  L_  M_  N_  O_  P_  R_  C_  T_  U_  F_  H_  TC  CH  SH  Sh  __  Y_  '_  JE  JU  JA  a_  b_  v_  g_  d_  e_  zh  z_  i_  j_  k_  l_  m_  n_  o_  p_  r_  s_  t_  u_  f_  h_  c_  ch  sh_  sh  __  y_  '_  je  ju  ja  JO  jo";
   AStr R = "";
   for (int i=1; i<=V.Length(); i++)
	{
	  if (((unsigned int)V[i])>=128)
	   {
		 AStr B = V.SubString(i,1) + " ";
		 if (C.Pos(B)>0)
		  {
			B = C.SubString(C.Pos(B)+2, 2);
			R = R                       + GetStrReplace(B, "_", "");
		  }
		 else R = R + V.SubString(i, 1);
	   }
	  else R = R + V.SubString(i, 1);
	}
   return R;
 }

void __fastcall TFormControlSkype::ButtonLastMessageClick(TObject *Sender)
 {
   if ((EditPathDB->Text!="")&&(FileExists(EditPathDB->Text)))
	{
	  if (DBSkype==0) DBSkype = new TSQLiteDatabase(EditPathDB->Text);
	  int res = DefineLastMessageSkype();
	  if (res<0) PageControl->ActivePage = TabSheetMessages;
	}
   else
	{
	  Inform("     Skype ( Main.db)");
	  PageControl->ActivePage = TabSheetMessages;
	}
 }

//---------------------------------------------------------------------------

TList* __fastcall TFormControlSkype::ReturnListHWNDWindowByCaptionAndClass(const AStr CaptionWindow,const AStr ClassWindow, HWND hParent)
 {
   //               
   //      , ..     
   TList* List = new TList();
   int length_caption = CaptionWindow.Length();
   int length_class   = ClassWindow.Length();
   AStr B  = "";
   char p[256];
   HWND hWND = 0;
   if (hParent==0)
	{
	  //hWND = GetWindow(GetForegroundWindow(),GW_HWNDFIRST);
	  hWND = GetWindow(Application->Handle,GW_HWNDFIRST);
	}
   else //  
	{
	  hWND = GetWindow(hParent,GW_CHILD);
	}
   while (hWND!=NULL)
	{
	  int l = GetClassName(hWND,p,sizeof(p));
	  bool find = 1;
	  if (length_class>0)
	   {
		 if (l>=length_class)
		  {
			B = p;
			if (B.Pos(ClassWindow)==0) find = 0;
		  }
		 else find = 0;
	   }
	  if (find)
	   {
		 l = GetWindowText(hWND, p, sizeof(p));
		 if (length_caption>0)
		  {
			if (l>=length_caption)
			 {
			   B = p;
			   if (B.Pos(CaptionWindow)==0) find = 0;
			 }
			else find = 0;
		  }
		 if (find)
		  {
			List->Add(hWND);
		  }
	   }
	  hWND = GetNextWindow(hWND,GW_HWNDNEXT);
	}
   return List;
 }

HWND __fastcall TFormControlSkype::DefineChatSkype(AStr CaptionWindow)
 {
   //        
  HWND res = 0;
  TList* List = ReturnListHWNDWindowByCaptionAndClass(CaptionWindow,"TConversationForm",0);
  for (int i=0; i<List->Count ;i++)
   {
	 HWND h1 = (HWND) List->Items[i];
	 TList* List2 = ReturnListHWNDWindowByCaptionAndClass("","TChatEntryControl",h1);
	 for (int i2=0; i2<List2->Count ;i2++)
	  {
		HWND h2 = (HWND) List2->Items[i2];
		TList* List3 = ReturnListHWNDWindowByCaptionAndClass("","TChatRichEdit",h2);
		for (int i3=0; i3<List3->Count ;i3++)
		 {
		   res = (HWND) List3->Items[i3];
		   break;
		   //Inform(A + " - " + IntToHex((int)h3,8));
		 }
		delete List3;
	  }
	 delete List2;
   }
  delete List;
  return res;
 }

int __fastcall TFormControlSkype::SendMessageInChatSkype(AStr CaptionWindow, TStrings* Ss)
 {
   //       
   int res = 0;
   HWND h  = DefineChatSkype(CaptionWindow);
   if (h)
	{
	  Clipboard()->AsText = Ss->Text;
	  Sleep(30);
	  //    
	  for (int i=0; i<sizeof(p); i++) p[i] = 0;
	  DWORD ThreadId = GetWindowThreadProcessId(h, NULL);
	  AttachThreadInput(GetCurrentThreadId(), ThreadId, 1);
	  GetKeyboardState(p);
	  p[VK_CONTROL] = 0x80;
	  SetKeyboardState(p);
	  PostMessage(h, WM_KEYDOWN, 0x56, 0); // Ctrl+ V
	  Sleep(10);
	  p[VK_CONTROL] = 0;
	  SetKeyboardState(p);
	  PostMessage(h, WM_KEYDOWN, 0x0D, 0); // 
	  AttachThreadInput(GetCurrentThreadId(), ThreadId, 0);
	  res = 1;
	  //Inform("  - " + CaptionWindow);
	}
   return res;
 }

AStr __fastcall TFormControlSkype::StrToNumUTF8(AStr Value)
 {
   AStr R = "";
   UnicodeString U = Value;
   int l = U.Length();
   for (int i=1; i<=U.Length(); i++)
	{
	  if (R!="") R = R + "-";
	  unsigned int n = U[i];
	  if      (n>=1088) n = n + 8040;
	  else if (n>=1040) n = n + 7104;
	  R = R + IntToStr((int)n);
	}
   return R;
 }

AStr __fastcall TFormControlSkype::TSToDate(int ts)
 {

   double d = (double)(ts+DeltaTime) / 86400 + DeltaDate;
   AStr R = FormatDateTime("yyyy-mm-dd",(System::TDateTime)d);
   return R;
 }

AStr __fastcall TFormControlSkype::TSToTime(int ts)
 {
   double d = (double)(ts+DeltaTime) / 86400 + DeltaDate;
   AStr R = FormatDateTime("hh-mm-ss",(System::TDateTime)d);
   return R;
 }

void __fastcall TFormControlSkype::ButtonDefWindowsSkypeClick(TObject *Sender)
{
  //     
  TStringList* Ss = new TStringList();
  Ss->Add(" ");
  int res = SendMessageInChatSkype("Skype KSU", Ss);
  delete Ss;
}

void __fastcall TFormControlSkype::ButtonExitClick(TObject *Sender)
{
  CanCloseProgram = 1;
  Close();
}

TMessageSkype* __fastcall TFormControlSkype::DefineMessageSkype(int id)
 {
   //    id
   TMessageSkype* MS = 0;
   for (int i=0; i<ListMS->Count; i++)
	{
	  TMessageSkype* MessageSkype = (TMessageSkype*) ListMS->Items[i];
	  if (MessageSkype->Id==id)
	   {
		 MS = MessageSkype;
		 break;
	   }
	}
   if (MS==0)
	{
	  MS = new TMessageSkype();
	  MS->Id = id;
	  ListMS->Add(MS);
	}
   return MS;
 }

int __fastcall TFormControlSkype::CreateQuestion(TMessageSkype* MS)
 {
   //     
   //    
   int res         = 0;
   MS->Path        = EditPathMan->Text + "\\"+ StrToNumUTF8(MS->UserName) + "\\"+TSToDate(MS->TS);
   MS->FneQuestion = TSToTime(MS->TS) + "-q.txt";
   AStr Pfne = MS->Path + "\\" + MS->FneQuestion;
   if (!FileExists(Pfne)) //     
	{
	  //  
	  if (!DirectoryExists(MS->Path)) ForceDirectories(MS->Path);
	  SLTemp->Text = MS->Question;
	  SLTemp->SaveToFile(Pfne);
	  res = 1;
	}
   else //      
	{
	  AStr Pfne = MS->Path + "\\"+ GetStrReplace(MS->FneQuestion, "-q.txt", "-a.txt");
	  if (FileExists(Pfne)) //  
	   {
		 SLTemp->LoadFromFile(Pfne);
		 MS->Ask = SLTemp->Text;
		 MS->Asked = 1;
	   }
	}
   return res;
 }

void __fastcall TFormControlSkype::TimerScanTimer(TObject *Sender)
 {
   //   
   //      Skype,        
   //      main.db
   //   ,      
   //          
   //      
   if (CheckBoxKeyInterval->Checked) Keystroke();
   if ((EditPathMan->Text!="")&&(DirectoryExists(EditPathMan->Text)))
	{
   if ((DBSkype!=0)&&(DBSkype->TableExists("Messages")))
	{

			//Inform(" Messages ");
			// Where -  
			//AStr A = "select [id], [author], [from_dispname], [dialog_partner], [body_xml], CONVERT(VARCHAR,timestamp,102) from Messages ORDER BY id DESC LIMIT 10";
			AStr A = "select id, author, from_dispname, dialog_partner, body_xml, timestamp from Messages ORDER BY id DESC LIMIT 10";
			TSQLiteTable* table = 0;
			try
			 {
			   table = DBSkype->GetTable(AnsiToUtf8(A));
			 }
			catch (...)
			 {
			   table = 0;
			 }
			if (table!=0)
			 {

			for (int i=0; i<table->Count; i++)
			 {
			   AStr UserName = CP1251ToAnsi(table->FieldAsString(2));
			   //if (UserName!="Skype KSU") {table->Next(); continue;} //  ,        
			   int id = StrToInt(CP1251ToAnsi(table->FieldAsString(0)));
			   //    
			   TMessageSkype* MS = DefineMessageSkype(id);
			   if (MS->Question=="") //     
				{
				  MS->Asked    = 0;
				  MS->UserName = UserName;
				  MS->Question = CP1251ToAnsi(table->FieldAsString(4));
				  MS->TS       = StrToInt(CP1251ToAnsi(table->FieldAsString(5)));
				  CreateQuestion(MS);
				}
			   table->Next();
			 }

			 delete table;
			 }
	}
   // ?         
   for (int i=0; i<ListMS->Count; i++)
	{
	  TMessageSkype* MS = (TMessageSkype*) ListMS->Items[i];
	  if (MS->Asked==0)
	   {
		 AStr Pfne = MS->Path + "\\" + GetStrReplace(MS->FneQuestion,"-q.txt","-a.txt");
		 if (FileExists(Pfne)) //  
		  {
			SLTemp->LoadFromFile(Pfne);
			MS->Ask = SLTemp->Text;
			SendMessageInChatSkype(MS->UserName,SLTemp); //   
			MS->Asked = 1;
		  }
	   }
	}
	}
   //TimerScan->Enabled = 0; //  
 }
//---------------------------------------------------------------------------

void __fastcall TFormControlSkype::EditPathDBExit(TObject *Sender)
{
  EditPathDBMan->Text = EditPathDB->Text;
}
//---------------------------------------------------------------------------

void __fastcall TFormControlSkype::ButtonAllToFileClick(TObject *Sender)
{
  //      
   if ((EditPathDB->Text!="")&&(FileExists(EditPathDB->Text)))
	{
	  if (DBSkype==0) DBSkype = new TSQLiteDatabase(EditPathDB->Text);
	  int res = AllMessagesToFile();
	}
   else
	{
	  Inform("     Skype ( Main.db)");
	}
   PageControl->ActivePage = TabSheetMessages;
}

void __fastcall TFormControlSkype::CheckBoxAutoNotificationClick(TObject *Sender)
 {
   MouseX = 0;
   MouseY = 0;
   MouseC = 0;
   TimerAutoNotification->Interval = 60000;
   TimerAutoNotification->Enabled  = CheckBoxAutoNotification->Checked;
   CheckBoxControl->Enabled        = 1 - CheckBoxAutoNotification->Checked;
 }

void __fastcall TFormControlSkype::TimerAutoNotificationTimer(TObject *Sender)
 {
   int max_minute = 5;
   if ((Mouse->CursorPos.x==MouseX)&&(Mouse->CursorPos.y==MouseY))
	{
	  if (MouseC<max_minute) MouseC++;
	  //Inform(MouseC);
	}
   else
	{
	  if ((CheckBoxControl->Checked)&&(MouseC==max_minute)) CheckBoxControl->Checked = 0;
	  TimerAutoNotification->Interval = 60000;
	  MouseX = Mouse->CursorPos.x;
	  MouseY = Mouse->CursorPos.y;
	  MouseC = 0;
	}
   if (MouseC==max_minute)
	{
	  //Inform(" ");
	  CheckBoxControl->Checked = 1;
	  TimerAutoNotification->Interval = 1000;
	}

 }
//---------------------------------------------------------------------------


